﻿Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.Linq
Imports System.Xml
Imports System.Xml.Linq

Namespace OrgCharts

    Public Class OrganizationViewModel

        Public Property Employees() As ObservableCollection(Of Employee)
            Get
                Return m_Employees
            End Get
            Set(value As ObservableCollection(Of Employee))
                m_Employees = value
            End Set
        End Property
        Private m_Employees As ObservableCollection(Of Employee)

    End Class

    Public Class Employee
        Implements INotifyPropertyChanged

        Public Property Id() As String
            Get
                Return m_Id
            End Get
            Set(value As String)
                m_Id = value
            End Set
        End Property
        Private m_Id As String

        Public Property Name() As String
            Get
                Return m_Name
            End Get
            Set(value As String)
                If Not m_Name = value Then
                    m_Name = value
                    OnPropertyChanged("Name")
                End If
                m_Name = value
            End Set
        End Property
        Private m_Name As String

        Public Property Attributes() As String
            Get
                Return m_Attributes
            End Get
            Set(value As String)
                m_Attributes = value
            End Set
        End Property
        Private m_Attributes As String

        Public Property Subordinates() As ObservableCollection(Of Employee)
            Get
                Return m_Subordinates
            End Get
            Set(value As ObservableCollection(Of Employee))
                m_Subordinates = value
            End Set
        End Property
        Private m_Subordinates As ObservableCollection(Of Employee)

        Protected Sub OnPropertyChanged(ByVal Name As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(Name))
        End Sub

        Public Event PropertyChanged(sender As Object, e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    End Class

End Namespace
